#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>

#include "unixatomic.h"
#include "prefix.h"


char *prefix_file;


int handle_prefix_file(int dst_fd)
{
	int fd;
	int ret = 0;
	char filebuf[8192];
	ssize_t n;

	if (prefix_file != NULL) {
		fd = open(prefix_file, O_RDONLY);
		if (fd == -1) {
			fprintf(stderr, "Can not open prefix file %s: %s\n", prefix_file, strerror(errno));
			goto out;
		}

		while (1) {
			n = read(fd, filebuf, sizeof filebuf);

			if (n < 0) {
				if (errno == EINTR || errno == EAGAIN)
					continue;

				fprintf(stderr,	"Read error on prefix file: %s: %s\n", prefix_file, strerror(errno));
				break;

			} else if (n == 0) {
				ret = 1; /* Success */
				break;
			}

			if (atomic_write(dst_fd, filebuf, n) != n) {
				fprintf(stderr,	"Can not write prefix to dest file: %s\n", strerror(errno));
				break;
			}
		}

		atomic_close(fd);
	} else {
		ret = 1;
	}

 out:
	return ret;
}
